window.Gleam.initSearch([{"doc":"puddle","title":"puddle","content":"![puddle](https://raw.githubusercontent.com/massivefermion/puddle/main/logo.png)\n\n[![Package Version](https://img.shields.io/hexpm/v/puddle)](https://hex.pm/packages/puddle)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/puddle/)\n\n# puddle\n\nA resource pool manager for gleam\n\n## Quick start\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add puddle\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/puddle&gt;.\n","url":"index.html"},{"doc":"puddle","title":"BookkeepingMessage","content":"pub opaque type BookkeepingMessage(resource_type, result_type)\n\n\nSynonyms:\npuddle.BookkeepingMessage\npuddle BookkeepingMessage","url":"puddle.html#BookkeepingMessage"},{"doc":"puddle","title":"UsageMessage","content":"pub opaque type UsageMessage(resource_type, result_type)\n\n\nSynonyms:\npuddle.UsageMessage\npuddle UsageMessage","url":"puddle.html#UsageMessage"},{"doc":"puddle","title":"apply","content":"pub fn apply(manager: Subject(BookkeepingMessage(a, b)), fun: fn(\n    a,\n  ) -&gt; b, timeout: Int, rest: fn(Result(b, Nil)) -&gt;\n    Result(c, Nil)) -&gt; Result(c, Nil)\n checks-out a resource, applies the function and then checks-in the resource\n\n ## Example\n\n \n &gt;  let assert Ok(manager) =\n &gt;    puddle.start(\n &gt;      4,\n &gt;      fn() {\n &gt;        Ok(int.random(1024, 8192))\n &gt;      },\n &gt;    )\n &gt;\n &gt;  let t1 =\n &gt;    task.async(fn() {\n &gt;      use r &lt;- puddle.apply(manager, fun, 32)\n &gt;      r\n &gt;   })\n\n &gt;  let t2 = \n &gt;    task.async(fn() {\n &gt;      use r &lt;- puddle.apply(manager, fun, 32)\n &gt;      r\n &gt;    })\n \n &gt;  task.await(t1, 32)\n &gt;  task.await(t2, 32)\n \nSynonyms:\npuddle.apply\npuddle apply","url":"puddle.html#apply"},{"doc":"puddle","title":"start","content":"pub fn start(size: Int, new_resource: fn() -&gt; Result(a, Nil)) -&gt; Result(\n  Subject(BookkeepingMessage(a, b)),\n  StartError,\n)\n\nSynonyms:\npuddle.start\npuddle start","url":"puddle.html#start"},{"doc":"puddle","title":"puddle","content":"","url":"puddle.html"}]);